classification
Title: IDLE calltips may not properly close on KeyboardInterrupt
Type: behavior Stage: resolved
Components: IDLE Versions: Python 3.9, Python 3.8, Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: terry.reedy Nosy List: ZackerySpytz, iritkatriel, miss-islington, rhettinger, taleinat, terry.reedy
Priority: normal Keywords: patch

Created on 2019-11-14 06:47 by ZackerySpytz, last changed 2020-10-10 14:51 by terry.reedy. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 17150 merged ZackerySpytz, 2019-11-14 06:53
PR 18287 merged miss-islington, 2020-01-31 01:55
PR 18288 merged miss-islington, 2020-01-31 01:56
Messages (8)
msg356580 - (view) Author: Zackery Spytz (ZackerySpytz) * (Python triager) Date: 2019-11-14 06:47
If a KeyboardInterrupt occurs while an IDLE calltip is being displayed,
the calltip will persist until a new calltip event. The calltip should
be removed immediately in this case.
msg356590 - (view) Author: Tal Einat (taleinat) * (Python committer) Date: 2019-11-14 10:17
Hi Zack, thanks for this!

This doesn't go far enough, actually; we should make sure to close the calltip in other cases too, such as restarting the shell or hitting return to running a statement / block.
msg361003 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-01-30 02:37
I verified problem for KeyboardInterrupt and RestartShell but not for a newline that actually runs the statement.  In my experiments, if a newline in inserted instead of running, the cursor remains within a call and the calltip should not disappear.
msg361087 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-01-31 01:55
New changeset bfdeaa37b3df7466624c17f9450d2bd1c3d95edf by Zackery Spytz in branch 'master':
bpo-38792: Remove IDLE shell calltip before new prompt. (#17150)
https://github.com/python/cpython/commit/bfdeaa37b3df7466624c17f9450d2bd1c3d95edf
msg361090 - (view) Author: miss-islington (miss-islington) Date: 2020-01-31 02:12
New changeset 8d021140866d050f90a4b44c2607f21be43208c1 by Miss Islington (bot) in branch '3.7':
bpo-38792: Remove IDLE shell calltip before new prompt. (GH-17150)
https://github.com/python/cpython/commit/8d021140866d050f90a4b44c2607f21be43208c1
msg361091 - (view) Author: miss-islington (miss-islington) Date: 2020-01-31 02:14
New changeset 83d3202b92fb4c2fc6df5b035d57f3a1cf715f20 by Miss Islington (bot) in branch '3.8':
bpo-38792: Remove IDLE shell calltip before new prompt. (GH-17150)
https://github.com/python/cpython/commit/83d3202b92fb4c2fc6df5b035d57f3a1cf715f20
msg361092 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-01-31 02:16
On the issue, Tal pointed out that SyntaxError leaves a calltip after a new >>> prompt.  Also fixed.
msg378406 - (view) Author: Irit Katriel (iritkatriel) * (Python committer) Date: 2020-10-10 14:19
This seems complete, can it be closed?
History
Date User Action Args
2020-10-10 14:51:11terry.reedysetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2020-10-10 14:19:05iritkatrielsetnosy: + iritkatriel
messages: + msg378406
2020-01-31 02:16:03terry.reedysetmessages: + msg361092
2020-01-31 02:14:20miss-islingtonsetmessages: + msg361091
2020-01-31 02:12:49miss-islingtonsetnosy: + miss-islington
messages: + msg361090
2020-01-31 01:56:03miss-islingtonsetpull_requests: + pull_request17662
2020-01-31 01:55:56miss-islingtonsetpull_requests: + pull_request17661
2020-01-31 01:55:49terry.reedysetmessages: + msg361087
2020-01-30 02:37:34terry.reedysetmessages: + msg361003
2019-11-14 10:17:00taleinatsetnosy: + taleinat
messages: + msg356590
2019-11-14 10:12:15taleinatsetnosy: + rhettinger
2019-11-14 06:53:19ZackerySpytzsetkeywords: + patch
stage: patch review
pull_requests: + pull_request16659
2019-11-14 06:47:31ZackerySpytzcreate